﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using rfid;

namespace UniqueCS
{
  public partial class Form1 : Form
  {
    static string MakeStringFromArray(sbyte[] Arr,int StringNummer)
    {
      string strLine;
      strLine = "";

      int i = 0;
      for (int aktStringNummer = 0; aktStringNummer <= StringNummer; aktStringNummer++)
      {
        strLine = "";
        for (; (i < Arr.Length); i++)
        {
          if (Arr[i] == 0)
          {
            break;
          }
          strLine += (char)Arr[i];
        }
        i++;
        if (strLine.Length == 0)
          break;
      }
      return strLine;
    }

    static sbyte[] MakeArrayFromString(string Name)
    {
      sbyte[] arr = new sbyte[Name.Length];
      for (int i = 0; i < Name.Length; i++)
        arr[i] = (sbyte)Name[i];
      return arr;
    }

    static string MakeStringFromByteArray(Byte[] Arr)
    {
      string strLine;
      strLine = "";

      int i = 0;
      for (; (i < Arr.Length); i++)
      {
        if (Arr[i] == 0)
        {
          break;
        }
        strLine += (char)Arr[i];
      }
      i++;
      return strLine;
    }

    static byte[] MakeByteArrayFromString(string Name)
    {
      byte[] arr = new byte[Name.Length];
      for (int i = 0; i < Name.Length; i++)
        arr[i] = (byte)Name[i];
      return arr;
    }

    static void CopyArrayTo(SByte[] Src, int SrcOffset, SByte[] Dest, int DestOffset, int Len)
    {
      while (Len > 0)
      {
        Dest[DestOffset++] = Src[SrcOffset++];
        Len--;
      }
    }

    static void CopyArrayTo(Byte[] Src, int SrcOffset, Byte[] Dest, int DestOffset, int Len)
    {
      while (Len > 0)
      {
        Dest[DestOffset++] = Src[SrcOffset++];
        Len--;
      }
    }

    static char cNibble(byte bVal)
    {
      if (bVal > 9)
        return (char)(bVal - 10 + 'A');
      else
        return (char)(bVal + '0');
    }

    static byte HexNibble(char Nibble)
    {
      if ((Nibble >= '0') && (Nibble <= '9'))
        return (byte)(Nibble - '0');
      else if ((Nibble >= 'A') && (Nibble <= 'F'))
        return (byte)(Nibble - 'A' + 10);
      else if ((Nibble >= 'a') && (Nibble <= 'f'))
        return (byte)(Nibble - 'a' + 10);
      else
        return 0;
    }

    static byte HexByte(char HiNibble, char LoNibble)
    {
      return (byte)(HexNibble(LoNibble) + HexNibble(HiNibble) * 16);
    }

    static string MakeHexString(byte[]Arr)
    {
      string strLine;
      strLine = "";
      for (int i = Arr.Length-1; (i >= 0) ;--i)
      {
        byte lChar = (byte)(Arr[i] & 0x0F);
        byte hChar = (byte)((Arr[i]>>4)&0x0F);

        strLine += cNibble(hChar);
        strLine += cNibble(lChar);
      }
      return strLine;
    }

    static byte[] FromHexString(string HexString,int Length)
    {
      while (HexString.Length < Length * 2)
        HexString.Insert(0, "0");
      byte[] arr = new byte[HexString.Length/2];
      for (int i = 0,j = Length-1; (j >= 0) && (i < HexString.Length/2); i++,j--)
        arr[j] = HexByte(HexString[i*2],HexString[i*2+1]);
      return arr;
    }

    int PortHandle;
    bool SelectTransponder(Byte[] UIDBuffer)
    {
      string ErrMsg;
      Byte[] Data = new Byte[100];

      UID.Text = "";

      // Read Single Slot Inventory, use Request Flag 0x20 for this
      if (GIS_HRW_API.TSHRW_ISO_Inventory(PortHandle, Data, Data.Length, 0x20) < 11)
      {
        ErrMsg = "Error " + GIS_HRW_API.TSHRW_GetLastError(PortHandle).ToString + " at ISO Inventory";
        MessageBox.Show(ErrMsg);

        return false;
      }
      else
      {
        CopyArrayTo(Data, 3, UIDBuffer, 0, 8);
        UID.Text = MakeHexString(UIDBuffer);
        return true;
      }
    }

    public Form1()
    {
      InitializeComponent();

      int MaxLen = 255;
      int ListLen = 0;
      int DevListLen;

      SByte[] NamenListe = new SByte[1000];
      SByte[] DevList = new SByte[MaxLen];

      DevListLen = GIS_HRW_API.TSHRW_ListAllDeviceNames(DevList, MaxLen) - 1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_HRW_API.TSHRW_LanListAllDeviceNames(DevList, MaxLen) - 1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_HRW_API.TSHRW_GetAvailablePorts(DevList, MaxLen) - 1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      ListLen++;

      if (ListLen > 1)
      {
        string DeviceName;
        // Use first Device in List
        DeviceName = MakeStringFromArray(NamenListe, 0);

        PortHandle = GIS_HRW_API.TSHRW_OpenPort(MakeArrayFromString(DeviceName), 19200, 500);
        if (GIS_HRW_API.TSHRW_IsProgrammer(PortHandle) != 1)
        {
          MessageBox.Show("Device is no Programmer");
        }
      }
      else
      {
        PortHandle = 0;
      }

      if (PortHandle <= 0)
      {
        MessageBox.Show("Device could not be opened");
      }
    }

    private void Close_Click(object sender, EventArgs e)
    {
      if (PortHandle > 0)
        GIS_HRW_API.TSHRW_ClosePort(PortHandle);
      Close();
    }

    private void Read_Click(object sender, EventArgs e)
    {
      if (PortHandle > 0)
      {
        Byte[] UIDBuffer = new Byte[8];

        Byte[] Buffer = new Byte[4];
        int iBlockNr = Convert.ToInt32(BlockNr.Text);

        BlockData.Text = "";

        if (!SelectTransponder(UIDBuffer))
          return;

        if (GIS_HRW_API.TSHRW_ISO_ReadSingleBlock(PortHandle, iBlockNr, Buffer, 4,UIDBuffer,UIDBuffer.Length,0) == 4)
        {
          BlockData.Text = MakeHexString(Buffer);
        }
        else
        {
          MessageBox.Show("Read Error");
        }
      }
      else
      {
        MessageBox.Show("No Device attached");
      }
    }

    private void Write_Click(object sender, EventArgs e)
    {
      if (PortHandle > 0)
      {
        Byte[] UIDBuffer = new Byte[8];

        Byte[] Buffer = FromHexString(BlockData.Text,4);
        int iBlockNr = Convert.ToInt32(BlockNr.Text);

        if (!SelectTransponder(UIDBuffer))
          return;


        if (GIS_HRW_API.TSHRW_ISO_WriteSingleBlock(PortHandle, iBlockNr, Buffer, 4, UIDBuffer, UIDBuffer.Length, 0) < 0)
        {
          MessageBox.Show("Write Error");
        }
        else
        {
          MessageBox.Show("Write OK");
        }
      }
      else
      {
        MessageBox.Show("No Device attached");
      }
    }
  }
}
