// TS_HRW_TestAppCpp.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#include "ISO15693 ReadCpp.h"
#include "..\..\TS_HRW_Import.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Das einzige Anwendungsobjekt

CWinApp theApp;


class CProgram
{
  CString MakeStringFromArray(CByteArray& Arr, int StringNummer)
  {
    CString strLine;
    strLine = "";

    int i = 0;
    for (int aktStringNummer = 0; aktStringNummer <= StringNummer; aktStringNummer++)
    {
      strLine = "";
      for (; (i < Arr.GetSize()); i++)
      {
        if (Arr[i] == 0)
        {
          break;
        }
        strLine += (char)Arr[i];
      }
      i++;
      if (strLine.GetLength() == 0)
        break;
    }
    return strLine;
  }

  static void MakeArrayFromString(CString Name, CByteArray &arr)
  {
    arr.SetSize(Name.GetLength() + 1);
    int i = 0;
    for (i = 0; i < Name.GetLength(); i++)
      arr[i] = (BYTE)Name[i];
    arr[i] = 0;
  }

  static CString MakeStringFromArray(const CByteArray &Arr)
  {
    CString strLine;
    strLine = "";

    for (int i = 0; (i < Arr.GetSize()) && (Arr[i] != 0); i++)
    {
      strLine += (char)Arr[i];
    }
    return strLine;
  }

  static void CopyArrayTo(CByteArray& Src, int SrcOffset, CByteArray& Dest, int DestOffset, int Len)
  {
    while (Len > 0)
    {
      Dest[DestOffset++] = Src[SrcOffset++];
      Len--;
    }
  }

public:
  void Main()
  {
    int MaxLen = 1000;
    int ReadLen = 0;
    int ListLen = 0;
    int Version;
    int TagCount;
    int DeviceCount;

    CByteArray NamenListe;
    NamenListe.SetSize(MaxLen);
    _tprintf(_T("C++ Test App for TS-HRW38"));
    _tprintf(_T("\n"));
    _tprintf(_T("\n"));

    Version = TSHRW_LibVersion();
    _tprintf(_T("Lib Version: "));
    _tprintf(_T("%d"),Version);
    _tprintf(_T("\n"));

    ListLen += TSHRW_GetAvailablePorts((char*)NamenListe.GetData()+ListLen, MaxLen-ListLen)-1;
    ListLen += TSHRW_ListAllDeviceNames((char*)NamenListe.GetData()+ListLen, MaxLen-ListLen)-1;
    ListLen += TSHRW_LanListAllDeviceNames((char*)NamenListe.GetData()+ListLen, MaxLen-ListLen)-1;
    ListLen++;
    if (ListLen > 1)
    {
      CString DeviceName;
      int DeviceNr;

      _tprintf(_T("Device found "));
      DeviceCount = 0;
      do
      {
        DeviceName = MakeStringFromArray(NamenListe, DeviceCount);
        if (DeviceName.GetLength() > 0)
        {
          _tprintf(_T("Device %d "), DeviceCount + 1);
          _tprintf(DeviceName);
          _tprintf(_T("\n"));
        }
        DeviceCount++;
      }
      while (DeviceName.GetLength() > 0);

      _tprintf(_T("Select Device:"));
      _tscanf_s(_T("%d"),&DeviceNr);

      DeviceName = MakeStringFromArray(NamenListe, DeviceNr - 1);
      CByteArray DeviceNameArr;
      MakeArrayFromString(DeviceName, DeviceNameArr);

      _tprintf(_T("Open Device: "));
      _tprintf(DeviceName);
      _tprintf(_T("\n"));

      // open with high baudrate suitable for Medio P200u
      int Handle = TSHRW_OpenPort((char*)DeviceNameArr.GetData(), 115200, 500);
      if (Handle < 0)
      {
        // if not opened try again with standard baudrate
        Handle = TSHRW_OpenPort((char*)DeviceNameArr.GetData(), 19200, 500);
      }

      if (Handle > 0)
      {
        if (TSHRW_IsProgrammer(Handle) != 1)
        {
          _tprintf(_T("Connected Device does not support Programmer mode! Please check Device!"));
          _tprintf(_T("\n"));
        }
        else
        {
          int BlockNr;
          if (TSHRW_SetRF(Handle, 1) < 0)
          {
            _tprintf(_T("Error at SetRF"));
            _tprintf(_T("\n"));
          }

          CByteArray Data;
          CByteArray UID;
          CByteArray BlockData;
          Data.SetSize(11 * 24); // Inventory of up to 24 chips
          UID.SetSize(8);
          BlockData.SetSize(16);

          ReadLen = TSHRW_ISO_Inventory(Handle, Data.GetData(), 11 * 24, 0);
          if (ReadLen < TSHRW_NO_ERROR)
          {
            _tprintf(_T("Error at Inventory"));
            _tprintf(_T("\n"));
            TagCount = 0;
          }
          else
          {
            _tprintf(_T("ReadLen %d "), ReadLen);
            _tprintf(_T("\n"));
            TagCount = ReadLen / 11; // For each Tag found 11 Bytes are returned
            for (int i = 0; i < TagCount; i++)
            {
              _tprintf(_T("Tag[%02d] "), i);
              for (int j = 7; j >= 0; j--)
                _tprintf(_T("%02X"), Data[i * 11 + 3 + j]);
              _tprintf(_T("\n"));
            }
          }

          if (TagCount > 0)
          {
            for (int i = 0; i < TagCount; i++)
            {
              CopyArrayTo(Data, i * 11 + 3, UID, 0, 8);
              _tprintf(_T("Read ["));
              for (int j = 7; j >= 0; j--)
                _tprintf(_T("%02X"), UID[j]);
              _tprintf(_T("] = "));
              BlockNr = 0;
              int BlockLength = TSHRW_ISO_ReadSingleBlock(Handle, BlockNr, BlockData.GetData(), (int)BlockData.GetSize(), UID.GetData(), 8, 0);
              //int BlockLength = TSHRW_ISO_ReadMultipleBlocks(Handle, BlockNr, 4, BlockData.GetData(), BlockData.GetSize(), UID.GetData(), 8, 0);
              if (BlockLength < TSHRW_NO_ERROR)
              {
                _tprintf(_T("Error "));
              }
              else
              {
                for (int j = 0; j < BlockLength; j++)
                  _tprintf(_T("%02X "), BlockData[j]);
              }
              _tprintf(_T("done"));
              _tprintf(_T("\n"));
            }

          }
          else
          {
            _tprintf(_T("No Tag Found "));
            _tprintf(_T("\n"));
          }
        }
        TSHRW_ClosePort(Handle);
      }
      else
      {
        _tprintf(_T("Error %d at TSHRW_OpenPort"),-Handle);
        _tprintf(_T("\n"));
      }
    }
    else
    {
      _tprintf(_T("No Device found"));
      _tprintf(_T("\n"));
    }
    _tprintf(_T("Wait for Key to exit"));
    while (!_kbhit());
  }
};

using namespace std;

int main()
{
  int nRetCode = 0;

  HMODULE hModule = ::GetModuleHandle(nullptr);

  if (hModule != nullptr)
  {
    // MFC initialisieren und drucken. Bei Fehlschlag Fehlermeldung aufrufen.
    if (!AfxWinInit(hModule, nullptr, ::GetCommandLine(), 0))
    {
      // TODO: Den Fehlercode an Ihre Anforderungen anpassen.
      wprintf(L"Schwerwiegender Fehler bei der MFC-Initialisierung\n");
      nRetCode = 1;
    }
    else
    {
      CProgram Program;
      Program.Main();
    }
  }
  else
  {
    // TODO: Den Fehlercode an Ihre Anforderungen anpassen.
    wprintf(L"Schwerwiegender Fehler: Fehler bei GetModuleHandle.\n");
    nRetCode = 1;
  }

  return nRetCode;
}
