﻿Imports System
Imports Microsoft


Module ISO15693_ReadVB

  Function MakeString(NamenListe() As Byte,StringNummer As Integer) As String
    MakeString = ""
    Dim i As Integer
    Dim StringFound As Boolean

    Dim aktStringNummer As Integer
    i = 0
    aktStringNummer = 0
    While (aktStringNummer <= StringNummer)
      MakeString = ""
      StringFound = False

      While (i < NamenListe.Length) And StringFound = False
        If (NamenListe(i) <> 0) Then
          MakeString = MakeString & Chr(NamenListe(i))
        Else
          StringFound = True
        End If
        i = i + 1
      End While
      If (MakeString.Length = 0)
        aktStringNummer = StringNummer+1
      End If
      aktStringNummer = aktStringNummer + 1
    End While
  End Function

  Function MakeArray(Name As String) As Byte()
    Dim i As Integer
    i = 0
    Dim NewArray(Name.Length) As Byte
    While i < Name.Length
      NewArray.SetValue(Convert.ToByte(Name(i)),i)
      i = i + 1
    End While
    MakeArray = NewArray
  End Function
  Sub CopyArrayTo(Src() As Byte, ByVal SrcOffset As Integer, Dest() As Byte, ByVal DestOffset As Integer, ByVal Len As Integer)
    While Len > 0
      Dest(DestOffset) = Src(SrcOffset)
      DestOffset = DestOffset + 1
      SrcOffset = SrcOffset + 1
      Len = Len - 1
    End While
  End Sub

  Sub Main()
    Dim MaxLen As Integer
    Dim ReadLen As Integer
    Dim ListLen As Integer
    Dim DevListLen As Integer
    MaxLen = 255
    ListLen = 0
    DevListLen = 0

    Dim DevList(255) As Byte
    Dim NamenListe(1000) As Byte
    Dim Version As Integer

    Console.Out.Write("VisualBasic Test App for TS-HRW38")
    Console.Out.WriteLine()
    Console.Out.WriteLine()

    Version = TSHRW_LibVersion()
    Console.Out.Write("Lib Version: ")
    Console.Out.Write(Version)
    Console.Out.WriteLine()

    DevListLen = TSHRW_GetAvailablePorts(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSHRW_ListAllDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSHRW_LanListAllDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    ListLen = ListLen + 1

    If (ListLen > 1) Then
      Console.Out.Write("Device found ")

      Dim DeviceName As String
      Dim DeviceCount As Integer
      Dim DeviceNr As Integer
      Dim DeviceNameArr(255) As Byte
      DeviceCount = 0
      Do
        DeviceName = MakeString(NamenListe,DeviceCount)
        If (DeviceName.Length > 0)
          Console.Out.Write("Device {0,0:D} ", DeviceCount + 1)
          Console.Out.Write(DeviceName)
          Console.Out.WriteLine()
        End If
        DeviceCount = DeviceCount + 1
      Loop While DeviceName.Length > 0

      Console.Out.Write("Select Device:")
      DeviceNr = Convert.ToInt32(Console.In.ReadLine())

      DeviceName = MakeString(NamenListe, DeviceNr - 1)
      DeviceNameArr = MakeArray(DeviceName)

      'open with high baudrate suitable for Medio P200u
      Dim Handle = TSHRW_OpenPort(DeviceNameArr(0), 115200, 500)
      If Handle < 0 Then
        'if not opened try again with standard baudrate
        Handle = TSHRW_OpenPort(DeviceNameArr(0), 19200, 500)
      End If

      If (Handle > 0) Then

        If (TSHRW_IsProgrammer(Handle) <> 1) Then
          Console.Out.Write("Connected Device does not support Programmer mode! Please check Device!")
          Console.Out.WriteLine()
        Else
          Dim BlockNr As Integer = 0
          Dim Data(11*24) As Byte
          Dim UID(8) As Byte
          Dim BlockData(16) As Byte
          Dim TagCount As Integer = 0
          Dim BlockLength As Integer

          If (TSHRW_SetRF(Handle, 1) < 0)
            Console.Out.Write("Error at SetRF")
            Console.Out.WriteLine()
          End If

          ReadLen = TSHRW_ISO_Inventory(Handle, Data(0), 11*24, 0)
          If (ReadLen < TSHRW_NO_ERROR) Then
            Console.Out.Write("Error at Inventory")
            Console.Out.WriteLine()
            TagCount = 0
          Else
            Console.Out.Write("ReadLen {0,2:D} ", ReadLen)
            Console.Out.WriteLine()
            TagCount = ReadLen / 11
            For i = 0 To TagCount-1
              Console.Write("Tag[{0,0:D2}] ", i)
              Console.Out.Write("{0,0:X2}{1,0:X2}{2,0:X2}{3,0:X2}{4,0:X2}{5,0:X2}{6,0:X2}{7,0:X2}", 
                                Data(i * 11 + 10), 
                                Data(i * 11 + 9), 
                                Data(i * 11 + 8), 
                                Data(i * 11 + 7), 
                                Data(i * 11 + 6), 
                                Data(i * 11 + 5), 
                                Data(i * 11 + 4), 
                                Data(i * 11 + 3))
              Console.Out.WriteLine()
            Next
          End If

          If (TagCount > 0)
            For i = 0 To TagCount-1
              CopyArrayTo(Data,i*11+3,UID,0,8)
              Console.Out.Write("Read [")
              Console.Out.Write("{0,0:X2}{1,0:X2}{2,0:X2}{3,0:X2}{4,0:X2}{5,0:X2}{6,0:X2}{7,0:X2}", 
                                UID(7), UID(6), UID(5), UID(4), UID(3), UID(2), UID(1), UID(0))
              Console.Out.Write("] = ")
              BlockNr = 0
              BlockLength = TSHRW_ISO_ReadSingleBlock(Handle, BlockNr, BlockData(0), BlockData.Length, UID(0), 8, 0)
              Rem BlockLength = TSHRW_ISO_ReadMultipleBlocks(Handle, BlockNr, 4, BlockData(0), BlockData.Length, UID(0), 8, 0)
              If (BlockLength < TSHRW_NO_ERROR)
                Console.Out.Write("Error {0,0:D} ",TSHRW_GetLastError(Handle))
              Else
                For j = 0 To BlockLength-1
                  Console.Out.Write("{0,0:X2} ",BlockData(j))
                Next
              End If
              Console.Out.Write("done")
              Console.Out.WriteLine()

            Next
          Else
            Console.Out.Write("no Tag found ")
            Console.Out.WriteLine()
          End If
        End If

        TSHRW_ClosePort(Handle)
      Else
        Console.Out.Write("Error ")
        Console.Out.Write(Handle)
        Console.Out.Write(" at TSHRW_OpenPort")
        Console.Out.WriteLine()
      End If

    Else
      Console.Out.Write("No Device found")
      Console.Out.WriteLine()
    End If

    Console.Out.Write("Wait for Key to exit")
    While Not Console.KeyAvailable
    End While
  End Sub

End Module
