Imports System.Runtime.InteropServices

Public Module [Lib]
  'Option Explicit

  'Fehlerliste  Dll Funktionsaufrufe
  Public Const TSHRW_NO_ERROR = 0
  Public Const TSHRW_PORT_OEFFNEN = 1
  Public Const TSHRW_TIMEOUT_UNGUELTIG = 2
  Public Const TSHRW_PORTHANDLE_UNGUELTIG = 3
  Public Const TSHRW_TIMEOUT = 4
  Public Const TSHRW_BUFFER_ZU_KLEIN = 5
  Public Const TSHRW_BUFFERGROESSE_FALSCH = 6
  Public Const TSHRW_FALSCHE_PARAMETER = 7
  Public Const TSHRW_KEINE_SENDEDATEN = 8
  Public Const TSHRW_KEINE_EMPFANGSDATEN = 9
  Public Const TSHRW_CHECKSUMMENFEHLER = 19
  Public Const TSHRW_KEINE_KOMMUNIKATION = 11
  Public Const TSHRW_CHECKBUFFER_LEER = 12
  Public Const TSHRW_MODE_UNGUELTIG = 13
  Public Const TSHRW_BEFEHL_NICHT_ERLAUBT = 14
  Public Const TSHRW_BLOCKNR_UNGUELTIG = 15
  Public Const TSHRW_KOMMANDOFEHLER = 16
  Public Const TSHRW_RF_IS_OFF = 17

  'Leserfehler
  Public Const TSHRW_DC3 = 19
  Public Const TSHRW_DC4 = 20
  Public Const TSHRW_NACK = 21
  Public Const TSHRW_SYNC = 22
  Public Const TSHRW_ETB = 23
  Public Const TSHRW_CANCEL = 24
  Public Const TSHRW_EM = 25
  Public Const TSHRW_MORE_DATA = 32

  ' Error codes Leser
  Public Const TSHRW_UNBEKANNTES_KOMMANDO = TSHRW_CANCEL
  Public Const TSHRW_DATENANZAHL = TSHRW_DC4
  Public Const TSHRW_KOLLISION = TSHRW_ETB
  Public Const TSHRW_NO_TAG = TSHRW_NACK
  Public Const TSHRW_NO_VALUE = TSHRW_DC3

  ' Error codes Leser
  Public Const TSHRW_ISO_ERROR_COMMAND_NOT_SUPPORTED = &H20
  Public Const TSHRW_ISO_ERROR_COMMAND_NOT_RECOGNIZED = &H21
  Public Const TSHRW_ISO_ERROR_COMMANDOPTION_NOT_SUPPORTED = &H22
  Public Const TSHRW_ISO_ERROR_NO_INFO = &H23
  Public Const TSHRW_ISO_ERROR_BLOCK_NOT_AVAILABLE = &H24
  Public Const TSHRW_ISO_ERROR_BLOCK_ALREADY_LOCKED = &H25
  Public Const TSHRW_ISO_ERROR_CANT_CHANGE_LOCKED_BLOCK = &H26
  Public Const TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_PROGRAMMED = &H27
  Public Const TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_LOCKED = &H28
  Public Const TSHRW_ISO_ERROR_UNKNOWN = &H29
  Public Const TSHRW_ISO_FEHLERLAENGE_NICHT_KORREKT = &H2A
  Public Const TSHRW_ISO_UNBEKANNTER_TAG = &H2B
  Public Const TSHRW_ISO_ERROR_FRAMING = &H2C

  ' Error codes Desfire
  ' Desfire TCL errors, generated by card
  Public Const TSHRW_DESFIRE_NO_CHANGES_DONE              =  &H1000C ' "No changes done";
  Public Const TSHRW_DESFIRE_OUT_OF_EEPROM_ERROR          =  &H1000E ' "Internal error, insufficient NV-Memory to complete operation";
  Public Const TSHRW_DESFIRE_ILLEGAL_COMMAND_CODE         =  &H1001C ' "Command code not supported";
  Public Const TSHRW_DESFIRE_INTEGRITY_ERROR              =  &H1001E ' "Integrity error, CRC or MAC does not match data / Padding bytes not valid"
  Public Const TSHRW_DESFIRE_NO_SUCH_KEY                  =  &H10040 ' "Invalid Key number specified";
  Public Const TSHRW_DESFIRE_INVALID_LENGTH               =  &H1007E ' "Internal error, length of Command string invalid";
  Public Const TSHRW_DESFIRE_PERMISSION_DENIED            =  &H1009D ' "Current config/status does not allow the requested command";
  Public Const TSHRW_DESFIRE_INVALID_PARAMETER_VALUE      =  &H1009E ' "Internal error, value of the parameter invalid";
  Public Const TSHRW_DESFIRE_APPLICATION_NOT_FOUND        =  &H100A0 ' "Requested AID not present on PICC";
  Public Const TSHRW_DESFIRE_APPLICATION_INTEGRITY_ERROR  =  &H100A1 ' "Unrecoverable error withing application, application will be disabled";
  Public Const TSHRW_DESFIRE_AUTHENTICATION_STATUS_ERROR  =  &H100AE ' "Current authentication status does not allow the requested command";
  Public Const TSHRW_DESFIRE_ADDITIONAL_FRAME             =  &H100AF ' "Internal error, additonal data frame is expected to be sent";
  Public Const TSHRW_DESFIRE_BOUNDARY_ERROR               =  &H100BE ' "Attempt to read/write data from/to beyond the file's limits";
  Public Const TSHRW_DESFIRE_PICC_INTEGRITY_ERROR         =  &H100C1 ' "Unrecoverable error in card, card will be disabled";
  Public Const TSHRW_DESFIRE_COMMAND_ABORTED              =  &H100CA ' "Previous command was not fully completed. Not all frames were requested or provided by the PCD";
  Public Const TSHRW_DESFIRE_PICC_DISABLED_ERROR          =  &H100CD ' "Card was disabled by an unrecoverable error";
  Public Const TSHRW_DESFIRE_APPLICATION_COUNT_ERROR      =  &H100CE ' "Max. number of applications reached. Number of applications limited to 28";
  Public Const TSHRW_DESFIRE_DUPLICATE_NUMBER_ERROR       =  &H100DE ' "Duplicate application/file number given";
  Public Const TSHRW_DESFIRE_EEPROM_ERROR                 =  &H100EE ' "Internal error, EEProm could not be written";
  Public Const TSHRW_DESFIRE_FILE_NOT_FOUND               =  &H100F0 ' "File not found";
  Public Const TSHRW_DESFIRE_FILE_INTEGRITY_ERROR         =  &H100F1 ' "Unrecoverable error in file";
  ' Desfire errors according to ISO 7816, generated by card
  Public Const TSHRW_DESFIRE_ISO7816_BOUNDARY_ERROR       =  &H16282 ' "End of file reached before reading all wished bytes";
  Public Const TSHRW_DESFIRE_ISO7816_WRONG_LENGTH         =  &H16700 ' "Internal error, wrong length";
  Public Const TSHRW_DESFIRE_ISO7816_NO_FILE_ACCESS       =  &H16982 ' "File access not allowed";
  Public Const TSHRW_DESFIRE_ISO7816_FILE_EMPTY           =  &H16985 ' "File empty";
  Public Const TSHRW_DESFIRE_ISO7816_WRONG_PARAMETER      =  &H16a86 ' "Internal error, wrong parameter P1 and/or P2";
  Public Const TSHRW_DESFIRE_ISO7816_WRONG_PARAMETER2     =  &H16a82 ' "Internal error, wrong parameter P1 and/or P2";
  Public Const TSHRW_DESFIRE_ISO7816_FILE_NOT_FOUND       =  &H16c00 ' "File not found";
  Public Const TSHRW_DESFIRE_ISO7816_UNKNOWN_ERROR        =  &H16f00 ' "No precise diagnostics";
  ' SDK specific Desfire errors
  Public Const TSHRW_DESFIRE_KEY_LENGTH_NOT_16_BYTES      =  &H10020 ' "Key length is not 16 bytes"
  Public Const TSHRW_DESFIRE_OLD_KEY_LENGTH_NOT_16_BYTES  =  &H10021 ' "Old key length is not 16 bytes"
  Public Const TSHRW_DESFIRE_KRYPT_3K3DES_NOT_SUPPORTED   =  &H10022 ' "Cryptmethod 3K3DES not supported"
  Public Const TSHRW_DESFIRE_AUTHENTICATION_MISSING       =  &H10023 ' "Command needs authentication";
  Public Const TSHRW_DESFIRE_MAC_DOES_NOT_MATCH_DATA      =  &H10024 ' "MAC does not match data"
  Public Const TSHRW_DESFIRE_CRC_DOES_NOT_MATCH_DATA      =  &H10025 ' "CRC after decryption does not match data"
  Public Const TSHRW_DESFIRE_PARAMETER_FIELD_TOO_SMALL    =  &H10026 ' "Length of parameter buffer smaller than data"
  Public Const TSHRW_DESFIRE_INVALID_PARA_LENGTH          =  &H10027 ' "Length of parameter field not valid"
  Public Const TSHRW_DESFIRE_NOT_ALLOWED_AFTER_AUTH_ISO   =  &H10028 ' "Not allowed after authentification with Authenticate ISO or Authenticate AES"

  ' Error codes NFC (Near Field Communication)
  Public Const TSHRW_NFC_NO_OR_UNSUPPORTED_TAG              = &H20001 ' "Transponder type is not supported in funktions for NFC"
  Public Const TSHRW_NFC_UNSUPPORTED_MIFARE_TAG             = &H20002 ' "This Mifare transponder type is not supported in funktions for NFC"
  Public Const TSHRW_NFC_ERROR_TAG_TYPE_NOT_DESFIRE         = &H20003 ' "Transponder is not of type DESFire"
  Public Const TSHRW_NFC_NOT_NFC_FORMATTED                  = &H20004 ' "Transponder is not NFC formated"
  Public Const TSHRW_NFC_ERR_AT_MIFARE_CLASSIC_AUTHENTICATE = &H20005 ' "Authentication of MifareClassic transponder failed"
  Public Const TSHRW_NFC_AUTHENT_DESFIRE_CARD_FAILED        = &H20006 ' "Authentication of DESFire card level failed"
  Public Const TSHRW_NFC_AUTHENT_DESFIRE_NFC_APP_FAILED     = &H20007 ' "Authentication of DESFire NFC application level failed"
  Public Const TSHRW_NFC_ERROR_AT_CHANGING_SETTINGS         = &H20008 ' "Error at changing settings"
  Public Const TSHRW_NFC_ERROR_AT_CHANGING_KEY              = &H20009 ' "Error at changing key"
  Public Const TSHRW_NFC_ERROR_AT_ISO15693_BLOCK_LOCKING    = &H2000A ' "Error at locking of blocks in ISO15693 transponder"
  Public Const TSHRW_NFC_ERROR_AT_NFC_FORMATTING            = &H2000B ' "Error at formating transponder as NFC"
  Public Const TSHRW_NFC_ERROR_NEWER_VERSION_NFC            = &H2000C ' "Error, NFc in transponder has newer version as NFC in SDK"
  Public Const TSHRW_NFC_ERROR_OLDER_VERSION_NFC            = &H2000D ' "Error, NFc in transponder has older version as NFC in SDK"
  Public Const TSHRW_NFC_WRITE_PROTECTED                    = &H2000E ' "Transponder is write protected"
  Public Const TSHRW_NFC_NFC_READ_PROTECTED                 = &H2000F ' "Transponder is NFC read protected"
  Public Const TSHRW_NFC_NFC_WRITE_PROTECTED                = &H20010 ' "Transponder is NFC write protected"
  Public Const TSHRW_NFC_ERROR_AT_BLOCK_READING             = &H20011 ' "Error at reading of blocks"
  Public Const TSHRW_NFC_ERROR_AT_BLOCK_WRITING             = &H20012 ' "Error at writing of blocks"
  Public Const TSHRW_NFC_ERROR_AT_FILE_WRITING              = &H20013 ' "Error at writing in DESFire file"
  Public Const TSHRW_NFC_NOT_ENOUGH_FREE_TAG_MEMORY         = &H20014 ' "Transponder has not enough free memory for this action"
  Public Const TSHRW_NFC_ID_OF_NFC_APP_NOT_FOUND            = &H20015 ' "ID of DESFire NFC application not found"
  Public Const TSHRW_NFC_IS_NFC_WITHOUT_DATA                = &H20016 ' "Transponder is NFC formated, but has no user data"
  Public Const TSHRW_NFC_ERROR_IN_NFC_DATA                  = &H20017 ' "Error in NFC structure"
  Public Const TSHRW_NFC_ERROR_IN_URL                       = &H20018 ' "Error in user data of type URL"
  Public Const TSHRW_NFC_ERROR_IN_MIME                      = &H20019 ' "Error in user data of type MIME"
  Public Const TSHRW_NFC_ERROR_IN_JSON                      = &H2001A ' "Error in given JSON-String"
  Public Const TSHRW_NFC_UNKNOWN_USER_DATA_TYPE             = &H2001B ' "Transponder is NFC formated and has userdata of unknown type"
  Public Const TSHRW_NFC_USER_DATA_NOT_OF_TYPE_URL          = &H2001C ' "Transponder has NFC user data but not of type URL"
  Public Const TSHRW_NFC_USER_DATA_NOT_OF_TYPE_TEXT         = &H2001D ' "Transponder has NFC user data but not of type Text"

  ' Defines zum anhngen falls kein UID
  Public Const _MYD1 = &H100
  Public Const _ICODE2 = &H200
  Public Const _TAGIT2 = &H400
  Public Const _E_MARIN = &H800
  Public Const _STM = &H1000
  Public Const _FUJITSU = &H2000
  Public Const _KSW = &H4000

  ' ISO Request flags
  Public Const ISO15693_TWO_SUBCARRIER_FLAG = &H1
  Public Const ISO15693_HIGH_DATARATE_FLAG = &H2
  Public Const ISO15693_INVENTORY_FLAG = &H4
  Public Const ISO15693_PROTOKOLL_EXTENSION = &H8

  ' ISO Request non inventory table
  Public Const ISO15693_SELECT_FLAG = &H10
  Public Const ISO15693_ADDRESS_FLAG = &H20
  Public Const ISO15693_OPTION_FLAG = &H40

  ' ISO Request inventory table
  Public Const ISO15693_AFI_FLAG = &H10
  Public Const ISO15693_SINGLE_SLOT_FLAG = &H20
  'Public Const  OPTION_FLAG    = &H40 (gilt fr inventory und non inventory table)

  ' Manufacturer Codes
  Public Const ISO15693_MFG_CODE_STM = &H2   ' ST Microelectronics
  Public Const ISO15693_MFG_CODE_PHILIPS = &H4   ' Philips
  Public Const ISO15693_MFG_CODE_INFINEON = &H5   ' Infineon
  Public Const ISO15693_MFG_CODE_TI = &H7   ' Texas Instruments
  Public Const ISO15693_MFG_CODE_FUJITSU = &H8   ' Fujitsu
  Public Const ISO15693_MFG_CODE_INSIDE = &H12   ' Inside Technology France
  Public Const ISO15693_MFG_CODE_ATMEL = &H15   ' ATMEL France
  Public Const ISO15693_MFG_CODE_EM = &H16   ' Electro Marin
  Public Const ISO15693_MFG_CODE_KSW = &H17   ' KSW Mikrotec
  Public Const ISO15693_MFG_CODE_SIC = &H39   ' Silicon Craft Thailand
  Public Const ISO15693_MFG_CODE_HID = &H3D   ' HID Global USA

  Public Const IGNORE_AUTOMATIC_FLAGS = &H8000


  ' Parameter fr Mifare Kommandos
  Public Const MIFARE_AUTH_A = &H0
  Public Const MIFARE_AUTH_B = &H1

  Public Const DEC_VALUE = &H0
  Public Const INC_VALUE = &H1

  ' Parameter fr SAM Access
  Public Const KEY_TYPE_AES128 = &H0
  Public Const KEY_TYPE_AES192 = &H1
  Public Const KEY_TYPE_AES256 = &H2
  Public Const KEY_TYPE_DES = &H3
  Public Const KEY_TYPE_2KTDES = &H4
  Public Const KEY_TYPE_3KTDES = &H5
  Public Const KEY_TYPE_MIFARE = &H6
  Public Const SAM_MODE_AV1 = &H100

  Public Const DIV_MODE_DESFIRE = &H0 '/**< DESFire Key Diversification. */
  Public Const DIV_MODE_MIFARE_PLUS = &H1 '/**< MIFARE Plus Key Diversification. */
  Public Const DIV_MODE_MASK = &HFF '/**< Bitmask for diversification Mode. */
  Public Const DIV_OPTION_2KTDES_FULL = &H0 '/**< Option for 2K3DES full-key diversification (only with #PH_CRYPTOSYM_DIV_MODE_DESFIRE). */
  Public Const DIV_OPTION_2KTDES_HALF = &H8000 '/**< Option for 2K3DES half-key diversification (only with #PH_CRYPTOSYM_DIV_MODE_DESFIRE). */


  ' Rckgabewerte
  Public Const TSHRW_RETVAL_ERROR = -1
  Public Const TSHRW_RETVAL_OK = 0
  '// Get Library Version
  Public Declare Function TSHRW_LibVersion Lib "TS_HRW_SDK64.DLL" () As Integer

  Public Declare Function TSHRW_IsVirtualComInstalled Lib "TS_HRW_SDK64.DLL" () As Integer

  Public Declare Function TSHRW_CountAllDevices Lib "TS_HRW_SDK64.DLL" () As Integer
  '// Get Names of all USB Devices connected, only valid devices are listed
  Public Declare Function TSHRW_ListAllDeviceNames Lib "TS_HRW_SDK64.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all USB Devices connected, all devices from GiS are listed
  Public Declare Function TSHRW_ListAllDeviceNamesEx Lib "TS_HRW_SDK64.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all COM Ports available, not tested if there is a device at the port connected.
  Public Declare Function TSHRW_GetAvailablePorts Lib "TS_HRW_SDK64.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all valid LAN devices found in same subnet
  Public Declare Function TSHRW_LanListAllDeviceNames Lib "TS_HRW_SDK64.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all LAN devices found even in other subnets
  Public Declare Function TSHRW_LanConfigListDevices Lib "TS_HRW_SDK64.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Change IP Address of LAN device
  Public Declare Function TSHRW_LanChangeIPAddress Lib "TS_HRW_SDK64.DLL" (<[In]()> ByRef OldAddress As Byte, <[In]()> ByRef NewAddress As Byte, <[In]()> IPMask As Byte) As Integer

  '// Change IP Address and Gateway of LAN device
  Public Declare Function TSHRW_LanChangeIPAddressEx Lib "TS_HRW_SDK64.DLL" (<[In]()> ByRef OldAddress As Byte, <[In]()> ByRef NewAddress As Byte, <[In]()> ByRef IPMask As Byte, <[In]()> ByRef GatewayAddress As Byte) As Integer

  '// Get IP Address and Gateway of LAN device
  Public Declare Function TSHRW_LanGetIPAddressEx Lib "TS_HRW_SDK64.DLL" (<[In]()> ByRef strName As Byte, <Out()> ByRef Address As Byte, <Out()> ByRef IPMask As Byte, <Out()> ByRef GatewayAddress As Byte) As Integer

  '// Check if specific LAN device is available
  Public Declare Function TSHRW_LanIsDeviceAvailable Lib "TS_HRW_SDK64.DLL" (<[In]()> ByRef Address As Byte) As Integer

  '// Open LAN Device for configuration
  Public Declare Function TSHRW_LanConfigOpen Lib "TS_HRW_SDK64.DLL" (<[In]()> ByRef strName As Byte) As Integer

  '// Set Configuration Record of LAN device, use with care!
  Public Declare Function TSHRW_LanConfigGet Lib "TS_HRW_SDK64.DLL" (ByVal nHandle As Integer, ByVal RecordNr As Integer, <Out()> ByRef pData As Byte, ByVal DatLen As Integer) As Integer

  '// Get Configuration Record of LAN device
  Public Declare Function TSHRW_LanConfigSet Lib "TS_HRW_SDK64.DLL" (ByVal nHandle As Integer, ByVal RecordNr As Integer, <[In]()> ByRef pData As Byte, ByVal DatLen As Integer) As Integer

  '// Close LAN device configuration.
  Public Declare Function TSHRW_LanConfigClose Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Reset As Integer) As Integer

  '// Read Configuration of USB HID device
  Public Declare Function TSHRW_HIDConfigRead Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pSendBuf As Byte, ByVal SendBufLen As Integer, <Out()> ByRef pRecvBuf As Byte, ByVal RecvBufLen As Integer) As Integer
  '// Write Configuration to USB HID device
  Public Declare Function TSHRW_HIDConfigWrite Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pSendBuf As Byte, ByVal SendBufLen As Integer) As Integer

  Public Declare Function TSHRW_OpenPort Lib "TS_HRW_SDK64.DLL" (<[In]()> ByRef Name As Byte, ByVal Baudrate As Integer, ByVal Timeout As Integer) As Integer
  Public Declare Function TSHRW_ClosePort Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_KeepAppActive Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal bActive As Integer) As Integer

  Public Declare Function TSHRW_SetReaderAdresse Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Adresse As Integer) As Integer

  Public Delegate Function AutoReadCallback (<MarshalAs(UnmanagedType.LPStr)> Arr As String, ByVal Len As Integer) As Integer 

  Public Declare Function TSHRW_StartAutoRead Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal TermChar As Integer, pAutoReadProc As AutoReadCallback) As Integer
  Public Declare Function TSHRW_StopAutoRead Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSHRW_DeviceVersion Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pDevVer As Byte, ByVal VerLen As Integer) As Integer
  Public Declare Function TSHRW_IsProgrammer Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_IsReader Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_IsUSB Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_SetBaudrate Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Baudrate As Integer, ByVal ParityMode As Integer) As Integer
  Public Declare Function TSHRW_SetReaderMode Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Mode As Integer) As Integer
  Public Declare Function TSHRW_SetRF Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal OnOff As Integer) As Integer
  Public Declare Function TSHRW_SetIO Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Maske As Integer, ByVal Daten As Integer) As Integer
  Public Declare Function TSHRW_ReadIO Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pDaten As Integer) As Integer

  Public Declare Function TSHRW_SetLED Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal red As Integer, ByVal green As Integer, ByVal yellow As Integer) As Integer
  Public Declare Function TSHRW_Beep Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSHRW_GetLastError Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_GetLastErrorMessage Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal language As Integer, <Out()> ByRef pMessageBuffer As Byte, ByVal MessageBufferLen As Integer) As Integer

  Public Declare Function TSHRW_ReadSerialNumber Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pSerial As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_SetConfig Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pConfig As Byte, ByVal ConfigLen As Integer) As Integer
  Public Declare Function TSHRW_GetConfig Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pConfig As Byte, ByVal ConfigLen As Integer) As Integer
  Public Declare Function TSHRW_SetDefault Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSHRW_GetActivationContext Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pData As Byte, ByVal Len As Integer) As Integer
  Public Declare Function TSHRW_WriteActivationContext Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pData As Byte, ByVal Len As Integer)As Integer
  Public Declare Function TSHRW_ReadCounter Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByRef pCounter As Integer) As Integer
  Public Declare Function TSHRW_DecrementCounter Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByRef pNewCounter As Integer) As Integer
  Public Declare Function TSHRW_GetDaysRemain Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByRef pDaysRemain As Integer) As Integer
  Public Declare Function TSHRW_UpdateDaysRemain Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByRef pDaysRemain As Integer) As Integer

  Public Declare Function TSHRW_SetCommunicationMode Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Mode As Integer) As Integer
  Public Declare Function TSHRW_RawWrite Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_RawRead Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_Transfer Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, pSendBuf As Byte, ByVal SendBufLen As Integer, <Out()> ByRef pRecvBuf As Byte, ByVal RecvBufLen As Integer) As Integer

  Public Declare Function TSHRW_ReadRegister Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Register As Integer, <Out()> ByRef pVal As Byte) As Integer
  Public Declare Function TSHRW_WriteRegister Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Register As Integer, ByVal Val As Byte) As Integer

  Public Declare Function TSHRW_ReadEEProm Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal StartAdresse As Integer, <Out()> ByRef pData As Byte, ByVal Len As Integer) As Integer
  Public Declare Function TSHRW_WriteEEProm Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal StartAdresse As Integer, <[In]()> ByRef pData As Byte, ByVal Len As Integer) As Integer

  Public Declare Function TSHRW_ISO_Inventory Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_InventoryAFI Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer, ByVal nRequestFlag As Integer, ByVal AFI As Integer) As Integer
  Public Declare Function TSHRW_ISO_GetSystemInfo Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_ReadSingleBlock Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nBlock As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_ReadMultipleBlocks Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nFirstBlock As Integer, ByVal nNumberOfBlocks As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_WriteSingleBlock Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nBlock As Integer, <[In]()> ByRef pBuffer As Byte, ByVal BufLen As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_SetAirProtokoll Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nAirSettings As Integer) As Integer
  Public Declare Function TSHRW_ISO_GetAirProtokoll Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByRef nAirSettings As Integer) As Integer
  Public Declare Function TSHRW_ISO_GetTagInfo Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, <Out()> ByRef BlockAnzahl As Integer, <Out()> ByRef BytesProBlock As Integer, <Out()> ByRef MfgCode As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_LockBlock Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nBlock As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_StayQuiet Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_Select Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_ResetToReady Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_GetMultipleBlockSecurityStatus Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nFirstBlock As Integer, ByVal nNumberOfBlocks As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_WriteAFI Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal AFI As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_LockAFI Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_WriteDSFID Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal DSFID As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_LockDSFID Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, ByVal nRequestFlag As Integer) As Integer
  Public Declare Function TSHRW_ISO_RawRequest Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nRequestFlag As Integer, ByVal nKommando As Integer, <[In]()> ByRef pParam As Byte, ByVal nParamLen As Integer, <[In]()> ByRef pData As Byte, ByVal nDataLen As Integer, <Out()> ByRef pReceive As Byte, ByVal nReceiveLen As Integer) As Integer

  Public Declare Function TSHRW_WriteTiming Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal nTiming As Integer) As Integer
  Public Declare Function TSHRW_SetComparator Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pParam As Byte, ByVal nParamLen As Integer) As Integer

  Public Declare Function TSHRW_Mifare_Request Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pATQA As Byte) As Integer
  Public Declare Function TSHRW_Mifare_RequestAll Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef ATQA As Byte) As Integer
  Public Declare Function TSHRW_Mifare_Select Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pUID As Byte, ByVal nUIDLen As Integer, <Out()> ByRef pSAK As Byte) As Integer
  Public Declare Function TSHRW_Mifare_SelectUID Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal nUIDLen As Integer, <Out()> ByRef pSAK As Byte) As Integer
  Public Declare Function TSHRW_Mifare_Halt Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_MifareSetKey Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal KeyType As Integer, ByVal nAdresse As Integer, <[In]()> ByRef pKey As Byte, ByVal nKeyLen As Integer) As Integer
  Public Declare Function TSHRW_MifareAuthenticate Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal nUIDLen As Integer, ByVal KeyType As Integer, ByVal nAdresse As Integer, ByVal BlockNr As Integer) As Integer
  Public Declare Function TSHRW_MifareAuthenticateDirect Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal nUIDLen As Integer, ByVal KeyType As Integer, <[In]()> ByRef pKey As Byte, ByVal nKeyLen As Integer, ByVal BlockNr As Integer) As Integer
  Public Declare Function TSHRW_MifareRead Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal BlockNr As Integer, <Out()> ByRef pData As Byte, ByVal nDataLen As Integer) As Integer
  Public Declare Function TSHRW_MifareWrite Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal BlockNr As Integer, <[In]()> ByRef pData As Byte, ByVal nDataLen As Integer) As Integer
  Public Declare Function TSHRW_MifareGetValue Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal BlockNr As Integer, ByRef pValue As Integer) As Integer
  Public Declare Function TSHRW_MifareSetValue Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal BlockNr As Integer, ByVal Value As Integer) As Integer
  Public Declare Function TSHRW_MifareChangeValue Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal BlockNr As Integer, ByVal Richtung As Integer, ByVal Differenz As Integer) As Integer
  Public Declare Function TSHRW_ISO14443SetCID Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal CID As Integer) As Integer
  Public Declare Function TSHRW_ISO14443Rats Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pData As Byte, ByVal MaxDataLen As Integer) As Integer
  Public Declare Function TSHRW_ISO14443PPS Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Speed As Integer) As Integer

  Public Declare Function TSHRW_ISO14443B_Transmit Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pSendData As Byte, ByVal nSendLen As Integer, <Out()> ByRef pRecvData As Byte, ByVal RecvLen As Integer) As Integer
  Public Declare Function TSHRW_ISO14443B_Request Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, <[In]()> ByRef pAppData As Byte, ByVal AppDataLen As Integer, <[In]()> ByRef pProtocolInfo As Byte, ByVal ProtocolInfoLen As Integer) As Integer
  Public Declare Function TSHRW_ISO14443B_Wakeup Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer, <[In]()> ByRef pAppData As Byte, ByVal AppDataLen As Integer, <[In]()> ByRef pProtocolInfo As Byte, ByVal ProtocolInfoLen As Integer) As Integer
  Public Declare Function TSHRW_ISO14443B_Select Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Speed As Integer, <[In]()> ByRef pUID As Byte, ByVal UIDLen As Integer) As Integer

  Public Declare Function TSHRW_ISO14443Transmit Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef pSendData As Byte, ByVal nSendLen As Integer, <Out()> ByRef pRecvData As Byte, ByVal RecvLen As Integer) As Integer

  Public Declare Function TSHRW_Desfire_GetVersion Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pVersionData As Byte, ByVal VersionDataLen As Integer) As Integer
  Public Declare Function TSHRW_Desfire_GetFreePICCMemory Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_Desfire_FormatPICC Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer) As Integer
  Public Declare Function TSHRW_Desfire_GetCardUID Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pUID As Byte, ByVal UIDBuffLen As Integer) As Integer
  Public Declare Function TSHRW_Desfire_SetConfiguration Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal Opt As Byte , <[In]()> ByRef pSettings As Byte, ByVal SettingsLen As Integer) As Integer
  Public Declare Function TSHRW_Desfire_Authenticate Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal KeyNo As Byte , <[In]()> ByRef pKey As Byte, ByVal KeySize As Integer) As Integer
  Public Declare Function TSHRW_Desfire_AuthenticateIso Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal KeyNo As Byte , <[In]()> ByRef pKey As Byte, ByVal KeySize As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_AuthenticateAES Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal KeyNo As Byte , <[In]()> ByRef pKey As Byte, ByVal KeySize As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_GetKeySettings Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pKeySettings As Byte, ByVal KeySettingsLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_ChangeKeySettings Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal ChangeKeyAuthentWith As Byte , ByVal OtherKeySettings As Byte ) As Integer
  Public Declare Function TSHRW_Desfire_ChangeKey Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal KeyNo As Byte , <[In]()> ByRef pNewKey As Byte, ByVal NewKeyLen As Integer , ByVal NewKeyVersion As Byte , <[In]()> ByRef pCurrentKey As Byte, ByVal CurrentKeyLen As Integer , ByVal NewMasterKeyCrypto As Byte ) As Integer
  Public Declare Function TSHRW_Desfire_GetKeyVersion Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal KeyNo As Byte ) As Integer
  Public Declare Function TSHRW_Desfire_GetApplicationIdsAndNames Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pAppNamesArray As Byte, ByVal AppNamesArrayLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_GetApplicationIds Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pAppIds As Byte, ByVal AppIdsLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_SelectApplication Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal AppId As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_CreateApplication Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal AppId As Integer , ByVal KeyCrypto As Byte , ByVal MaxNoOfKeys As Byte , ByVal bFilesWithIsoID As Integer , ByVal ChangeKeyAuthentWith As Byte , ByVal OtherKeySettings As Byte , <[In]()> ByRef pIso7816Data As Byte, ByVal Iso7816DataLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_DeleteApplication Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal AppId As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_GetFileIds Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pFileIds As Byte, ByVal FileIdsLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_GetFileIsoIds Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef pFileIds As Byte, ByVal FileIdsLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_GetFileSettings Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Integer , <Out()> ByRef pFileSettings As Byte, ByVal FileSettingsBufferLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_ChangeFileSettings Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Integer , ByVal bChangeAccessRightsFree As Integer , <[In]()> ByRef pFileSettings As Byte, ByVal FileSettingsLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_CreateStandardDataFile Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal IsoFileId As Integer , ByVal FileSize As Integer , ByVal CommunicationMode As Byte , ByVal AccessRights As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_CreateBackupDataFile Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal IsoFileId As Integer , ByVal FileSize As Integer , ByVal CommunicationMode As Byte , ByVal AccessRights As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_CreateValueFile Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , ByVal AccessRights As Integer , ByVal LowerLimit As Integer , ByVal UpperLimit As Integer , ByVal InitialValue As Integer , ByVal Config As Byte ) As Integer
  Public Declare Function TSHRW_Desfire_CreateLinearRecordFile Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal IsoFileId As Integer , ByVal CommunicationMode As Byte , ByVal AccessRights As Integer , ByVal RecordSize As Integer , ByVal MaxCountRecords As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_CreateCyclicRecordFile Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal IsoFileId As Integer , ByVal CommunicationMode As Byte , ByVal AccessRights As Integer , ByVal RecordSize As Integer , ByVal MaxCountRecords As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_DeleteFile Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte ) As Integer
  Public Declare Function TSHRW_Desfire_ReadData Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , ByVal StartIndex As Integer , ByVal ReadCount As Integer , <Out()> ByRef pReadData As Byte, ByVal ReadDataBufferLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_WriteData Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , ByVal OffsetInFile As Integer , <[In]()> ByRef pWriteData As Byte, ByVal WriteDataLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_GetValue Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , <Out()> ByRef pValue As Integer) As Integer
  Public Declare Function TSHRW_Desfire_Credit Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , ByVal Value As Integer) As Integer
  Public Declare Function TSHRW_Desfire_LimitedCredit Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , ByVal Value As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_Debit Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte  , ByVal Value As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_ReadRecord Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , ByVal StartRecord As Integer , ByVal ReadCountRecords As Integer , ByVal RecordSize As Integer , <Out()> ByRef pReadData As Byte, ByVal ReadDataBufferLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_WriteRecord Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal FileId As Byte , ByVal CommunicationMode As Byte , ByVal OffsetInRecord As Integer , <[In]()> ByRef pWriteData As Byte, ByVal WriteDataLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_ClearRecordFile Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal FileId As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_CommitTransaction Lib "TS_HRW_SDK64.DLL" (ByVal handle) As Integer
  Public Declare Function TSHRW_Desfire_AbortTransaction Lib "TS_HRW_SDK64.DLL" (ByVal handle) As Integer
  Public Declare Function TSHRW_Desfire_IsoSelectApplication Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <[In]()> ByRef pAppName As Byte, ByVal AppNameLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_IsoSelectFile Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal IsoFileId As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_IsoReadData Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal StartIndex As Integer , ByVal ReadCount As Integer , <Out()> ByRef pReadData As Byte, ByVal ReadDataBufferLen As Integer ) As Integer
  Public Declare Function TSHRW_Desfire_IsoWriteData Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal StartIndex As Integer , <[In]()> ByRef WriteData As Byte, ByVal WriteDataLen As Integer) As Integer
  Public Declare Function TSHRW_DesfireISO7816EnableWrapping Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal bOn As Integer) As Integer

  Public Declare Function TSHRW_Nfc_ReadTag Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <Out()> ByRef pReadData As SByte, ByVal ReadDataBufferLen As Integer) As Integer
  Public Declare Function TSHRW_Nfc_ReadUrl Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <Out()> ByRef pUrl As SByte, ByVal UrlLen As Integer, <Out()> ByRef pText As SByte, ByVal TextLen As Integer) As Integer
  Public Declare Function TSHRW_Nfc_ReadText Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <Out()> ByRef pText As SByte, ByVal TextLen As Integer) As Integer
  Public Declare Function TSHRW_Nfc_ReadTagUid Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <Out()> ByRef pReadData As Byte, ByVal ReadDataLen As Integer) As Integer
  Public Declare Function TSHRW_Nfc_WriteTag Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <[In]()> ByRef pWriteData As SByte, ByVal WriteDataLen As Integer, <[In]()> ByRef pKey As Byte, ByVal Keylen As Integer, ByVal Lock As Integer) As Integer
  Public Declare Function TSHRW_Nfc_WriteUrl Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <[In]()> ByRef pUrl As SByte, ByVal UrlLen As Integer, <[In]()> ByRef pText As SByte, ByVal TextLen As Integer, <[In]()> ByRef pKey As Byte, ByVal Keylen As Integer, ByVal Lock As Integer) As Integer
  Public Declare Function TSHRW_Nfc_WriteText Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <[In]()> ByRef pText As SByte, ByVal TextLen As Integer, <[In]()> ByRef pKey As Byte, ByVal Keylen As Integer, ByVal Lock As Integer) As Integer
  Public Declare Function TSHRW_Nfc_FormatTag Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <[In]()> ByRef pKey As Byte, ByVal Keylen As Integer) As Integer
  Public Declare Function TSHRW_Nfc_LockTag Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, <[In]()> ByRef pKey As Byte, ByVal Keylen As Integer) As Integer
  Public Declare Function TSHRW_Nfc_SetTagPasswordProtected Lib "TS_HRW_SDK64.DLL" (ByVal Porthandle As Integer, ByVal bUserDataToo As Integer, <[In]()> ByRef pOldKey As Byte, ByVal OldKeylen As Integer, <[In]()> ByRef pNewKey As Byte, ByVal NewKeylen As Integer) As Integer

  Public Declare Function TSHRW_WriteParam Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_ReadParam Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_WritePrefix Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_ReadPrefix Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_WriteSuffix Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_ReadSuffix Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_WriteTermix Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_ReadTermix Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_WritePostcode Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_ReadPostcode Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_WriteReadModeParam Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_ReadReadModeParam Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSHRW_WriteMifareKey Lib "TS_HRW_SDK64.DLL" (ByVal handle As Integer, ByVal KeyType As Integer, <[In]()> ByRef pKey As Byte, ByVal KeyLen As Integer) As Integer

End Module
